---
title: encodeURI()
slug: Web/JavaScript/Reference/Global_Objects/encodeURI
tags:
  - Encoding
  - JavaScript
  - Method
  - Text
  - URI
  - URL
  - encodeURI
---
<div>{{jsSidebar("Objects")}}</div>

<p>The <code><strong>encodeURI()</strong></code> function encodes a {{glossary("URI")}} by replacing each instance of certain characters by one, two, three, or four escape sequences representing the {{glossary("UTF-8")}} encoding of the character (will only be four escape sequences for characters composed of two "surrogate" characters).</p>

<div>{{EmbedInteractiveExample("pages/js/globalprops-encodeuri.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">encodeURI(<var>URI</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>URI</var></code></dt>
 <dd>A complete URI.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new string representing the provided string encoded as a URI.</p>

<h2 id="Description">Description</h2>

<p>The <code>encodeURI()</code> function does not encode characters that have special meaning (reserved characters) for a URI. The following example shows all the parts that a URI "scheme" can possibly contain. Note how certain characters are used to signify special meaning:</p>

<pre class="notranslate">http://username:password@www.example.com:80/path/to/file.php?foo=316&amp;bar=this+has+spaces#anchor</pre>

<p>Hence <code>encodeURI()</code> <strong>does not</strong> encode characters that are necessary to formulate a complete URI. Also, <code>encodeURI()</code> <strong>does not</strong> encode a few additional characters, known as "unreserved marks", which do not have a reserved purpose but are allowed in a URI "as is". (See <a href="https://www.ietf.org/rfc/rfc2396.txt">RFC2396)</a></p>

<p><code>encodeURI()</code> escapes all characters <strong>except</strong>:</p>

<pre class="notranslate"><strong>Not Escaped</strong>:

    A-Z a-z 0-9 ; , / ? : @ &amp; = + $ - _ . ! ~ * ' ( ) #<code>
</code>
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="encodeURI_vs_encodeURIComponent">encodeURI vs encodeURIComponent</h3>

<p><code>encodeURI()</code> differs from {{jsxref("encodeURIComponent", "encodeURIComponent()")}} as follows:</p>

<pre class="brush: js notranslate">var set1 = ";,/?:@&amp;=+$#"; // Reserved Characters
var set2 = "-_.!~*'()";   // Unreserved Marks
var set3 = "ABC abc 123"; // Alphanumeric Characters + Space

console.log(encodeURI(set1)); // ;,/?:@&amp;=+$#
console.log(encodeURI(set2)); // -_.!~*'()
console.log(encodeURI(set3)); // ABC%20abc%20123 (the space gets encoded as %20)

console.log(encodeURIComponent(set1)); // %3B%2C%2F%3F%3A%40%26%3D%2B%24%23
console.log(encodeURIComponent(set2)); // -_.!~*'()
console.log(encodeURIComponent(set3)); // ABC%20abc%20123 (the space gets encoded as %20)
</pre>

<p>Note that <code>encodeURI()</code> by itself <em>cannot</em> form proper HTTP {{HTTPMethod("GET")}} and {{HTTPMethod("POST")}} requests, such as for {{domxref("XMLHttpRequest")}}, because "<code>&amp;</code>", "<code>+</code>", and "<code>=</code>" are not encoded, which are treated as special characters in <code>GET</code> and <code>POST</code> requests. <code>encodeURIComponent()</code>, however, does encode these characters.</p>

<h3 id="Encoding_a_lone_high_surrogate_throws">Encoding a lone high surrogate throws</h3>

<p>An {{jsxref("URIError")}} will be thrown if one attempts to encode a surrogate which is not part of a high-low pair, e.g.,</p>

<pre class="brush: js notranslate">// high-low pair ok
console.log(encodeURI('\uD800\uDFFF'));

// lone high surrogate throws "URIError: malformed URI sequence"
console.log(encodeURI('\uD800'));

// lone low surrogate throws "URIError: malformed URI sequence"
console.log(encodeURI('\uDFFF'));</pre>

<h3 id="Encoding_for_IPv6">Encoding for IPv6</h3>

<p>If one wishes to follow the more recent <a href="http://tools.ietf.org/html/rfc3986">RFC3986</a> for URLs, which makes square brackets reserved (for {{glossary("IPv6")}}) and thus not encoded when forming something which could be part of a URL (such as a host), the following code snippet may help:</p>

<pre class="brush: js notranslate">function fixedEncodeURI(str) {
    return encodeURI(str).replace(/%5B/g, '[').replace(/%5D/g, ']');
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-encodeuri-uri', 'encodeURI')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.encodeURI")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("decodeURI", "decodeURI()")}}</li>
 <li>{{jsxref("encodeURIComponent", "encodeURIComponent()")}}</li>
 <li>{{jsxref("decodeURIComponent", "decodeURIComponent()")}}</li>
</ul>
